//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "FTLM_KG Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;
extern string soundFile        = "alert2.wav";

//
//
//
//
//

double Up[];
double Dn[];
double ftlm[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,Up); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ftlm); 
   SetIndexBuffer(3,trend); 
   
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
       
   IndicatorShortName(timeFrameToString(timeFrame)+"  Ftlm_KG_hist");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
return(0);
}
int deinit() 
{  
   deleteArrows(); 
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { Up[0] = MathMin(limit+1,Bars-1); return(0); }            

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for (i=limit;i>=0;i--)
     {

        double value1 =
0.216679747671846*Close[i+0]
+0.211269420463811*Close[i+1]
+0.195544884029715*Close[i+2]
+0.170965415406708*Close[i+3]
+0.139777024336523*Close[i+4]
+0.10475520757496*Close[i+5]
+0.0688963726406815*Close[i+6]
+0.0350907878482374*Close[i+7]
+0.00582303578389499*Close[i+8]
-0.0170687325113629*Close[i+9]
-0.0325430291353946*Close[i+10]
-0.0404061862801786*Close[i+11]
-0.0412576874250575*Close[i+12]
-0.0363489006817302*Close[i+13]
-0.0273726712811041*Close[i+14]
-0.0162239477577438*Close[i+15]
-0.00474919988104162*Close[i+16]
+0.00546044031567738*Close[i+17]
+0.0132340752866597*Close[i+18]
+0.0179048641241163*Close[i+19]
+0.0193288196450583*Close[i+20]
+0.0178203001317383*Close[i+21]
+0.0140521142662672*Close[i+22]
+0.00890900942687798*Close[i+23]
+0.00332796683926323*Close[i+24]
-0.00183047425117888*Close[i+25]
-0.00590003260461143*Close[i+26]
-0.008470924607332*Close[i+27]
-0.00941376204563632*Close[i+28]
-0.00885433738048246*Close[i+29]
-0.00711869639879854*Close[i+30]
-0.00465317542176635*Close[i+31]
-0.00194019707183346*Close[i+32]
+0.000579603884990088*Close[i+33]
+0.00256707017356023*Close[i+34]
+0.00381977207432852*Close[i+35]
+0.00428068634338846*Close[i+36]
+0.00402313632832263*Close[i+37]
+0.0032179506176373*Close[i+38]
+0.00209012998360153*Close[i+39]
+0.000874173133673174*Close[i+40]
-0.000224786383933042*Close[i+41]
-0.0010587336898008*Close[i+42]
-0.00155052433232022*Close[i+43]
-0.00169306769372935*Close[i+44]
-0.00153786701404679*Close[i+45]
-0.00117483219738423*Close[i+46]
-0.000710127079707358*Close[i+47]
-0.000243983404727185*Close[i+48]
+0.000144391315936508*Close[i+49]
+0.000408472741254023*Close[i+50]
+0.000535354473765889*Close[i+51]
+0.000542366420043941*Close[i+52]
+0.000469190409143627*Close[i+53]
+0.000367676722499057*Close[i+54]
-0.000413583883278278*Close[i+55];

        double value2 =
0.0364298167208155*Close[i+0]
+0.0553906231378775*Close[i+1]
+0.0739088457518267*Close[i+2]
+0.0904000966980787*Close[i+3]
+0.103396797434432*Close[i+4]
+0.111711342284296*Close[i+5]
+0.114572120305459*Close[i+6]
+0.111711342284296*Close[i+7]
+0.103396797434432*Close[i+8]
+0.0904000966980787*Close[i+9]
+0.0739088457518267*Close[i+10]
+0.0553906231378775*Close[i+11]
+0.0364298167208155*Close[i+12]
+0.0185546919366474*Close[i+13]
+0.00307900283041587*Close[i+14]
-0.00902530529856102*Close[i+15]
-0.0172075327263682*Close[i+16]
-0.0213652751829327*Close[i+17]
-0.0218155170382955*Close[i+18]
-0.0192199347960543*Close[i+19]
-0.0144736414953281*Close[i+20]
-0.00857861481888381*Close[i+21]
-0.00251119869748709*Close[i+22]
+0.00288727595213947*Close[i+23]
+0.00699768244225111*Close[i+24]
+0.00946742032203178*Close[i+25]
+0.0102203545718079*Close[i+26]
+0.0094227060558747*Close[i+27]
+0.00743023076018664*Close[i+28]
+0.00471074990083792*Close[i+29]
+0.00175970399253971*Close[i+30]
-0.000967886100918518*Close[i+31]
-0.00311971586013391*Close[i+32]
-0.00447910708609257*Close[i+33]
-0.00497764414629577*Close[i+34]
-0.00468184137410999*Close[i+35]
-0.00376409954776387*Close[i+36]
-0.00246042456645472*Close[i+37]
-0.00102590341145799*Close[i+38]
+0.000306472786469948*Close[i+39]
+0.00135737038610145*Close[i+40]
+0.00201975214731277*Close[i+41]
+0.00226346631835387*Close[i+42]
+0.00212728353418576*Close[i+43]
+0.0017015315425756*Close[i+44]
+0.00110518230941413*Close[i+45]
+0.000462229952338165*Close[i+46]
-0.000118858605382952*Close[i+47]
-0.000559818649332224*Close[i+48]
-0.000819859088114563*Close[i+49]
-0.000895230669111811*Close[i+50]
-0.00081316637313982*Close[i+51]
-0.000621207183890965*Close[i+52]
-0.000375488554341561*Close[i+53]
-0.000129009269667756*Close[i+54]
+0.0000763487100123232*Close[i+55]
+0.000215985058849768*Close[i+56]
+0.000283075358142209*Close[i+57]
+0.000286783012231603*Close[i+58]
+0.000248090283379797*Close[i+59]
+0.000194413654881473*Close[i+60]
-0.000218687638971784*Close[i+61];


       ftlm[i]  = value1-value2;
       Up[i]    = EMPTY_VALUE;
       Dn[i]    = EMPTY_VALUE;
       trend[i] = trend[i+1];
       if (ftlm[i]>ftlm[i+1]) trend[i] = 1;
       if (ftlm[i]<ftlm[i+1]) trend[i] =-1;
       if (trend[i] == 1)     Up[i] = ftlm[i];
       if (trend[i] ==-1)     Dn[i] = ftlm[i];
       
       //
       //
       //
       //
       //
     
       if (ShowArrows)
       {
          deleteArrow(Time[i]);
          if (trend[i] != trend[i+1])
          {
             if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
             if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
           }
         }
       }
   manageAlerts(); 
   return(0);
   }      
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));      
   for(i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ftlm[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,2,y);
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,3,y);
         Up[i]    = EMPTY_VALUE;
         Dn[i]    = EMPTY_VALUE;
         if (trend[i] == 1) Up[i] = ftlm[i];
         if (trend[i] ==-1) Dn[i] = ftlm[i];
   }
manageAlerts(); 
return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"trend");
         if (trend[whichBar] ==-1) doAlert(whichBar,"no trend");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" FTLM_KG ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," FTLM_KG "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



